/*
 * File         : Connector.h
 * Author       : Tomasz Stachowiak
 * Created      : Wed May 20 18:02:28 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#ifndef __CONNECTOR_H
#define __CONNECTOR_H

template <class SVC_HANDLER, class PEER_CONNECTOR>
class Connector
{
 public:

  Connector(Reactor *reactor);
  virtual int connect(PEER_CONNECTOR::PEER_ADDR *addr, SVC_HANDLER *sh);
  virtual int close();

 private:

  Reactor *reactor_;
  PEER_CONNECTOR peer_connector_;
};

#define SH SVC_HANDLER
#define PC PEER_CONNECTOR

template <class SH, class PC>
Connector<SH, PC>::Connector(Reactor *reactor)
{
  reactor_ = reactor;
}


template <class SH, class PC>
int Connector<SH, PC>::connect(PEER_CONNECTOR::PEER_ADDR *addr, SH *sh)
{

  if(this->peer_connector_.connect(addr, sh->peer()) == -1)
    {
      BVN_ERROR("Connector::connect\n");
      return -1;
    }

  if(sh->open(reactor_) == -1)
    {
      BVN_ERROR("Connector: connect\n");
      return -1;
    }

  return 0;
}

template <class SH, class PC>
Connector<SH, PC>::close(void)
{
  return this->peer_connector_.close();
}

#endif

